diff --git a/build.gradle.kts b/build.gradle.kts
index 9b61f98b1..6afe1dc86 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -26,3 +26,22 @@ ext["lwjglNatives"] = Pair(
             throw Error("Unrecognized or unsupported platform. Please set \"lwjglNatives\" manually")
     }
 }
+
+plugins {
+    id("java")
+}
+
+
+
+val genJavadoc by tasks.registering(Javadoc::class) {
+    val exposedProjects = listOf(
+        ":game:core",
+        ":game:client",
+        ":game:server",
+    )
+    val sourceSets = exposedProjects.map { project(it).sourceSets["main"] }
+    classpath = files(sourceSets.map { it.compileClasspath })
+    setSource(exposedProjects.map { project(it).sourceSets["main"].allJava })
+    setDestinationDir(file("${layout.buildDirectory.get()}/docs/javadoc"))
+    print(destinationDir)
+}
\ No newline at end of file
diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index 5e85d1edc..1e3053fb0 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -45,7 +45,7 @@ dependencies {
     implementation(project(":util:logging"))?.let { include(it) }
     // </core dependencies>
 
-    implementation("com.github.Better-than-Adventure:legacy-lwjgl3:1.0.5")?.let { include(it) }
+    implementation("com.github.Better-than-Adventure:legacy-lwjgl3:1.0.6")?.let { include(it) }
 
     implementation("org.apache-extras.beanshell:bsh:2.0b6")?.let { include(it) }
     implementation("com.deepoove:codehighlight:1.0.3")?.let { include(it) }
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 3b5c24ef7..b4018277a 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1047,7 +1047,7 @@ public class Minecraft
                     if (this.currentScreen instanceof ScreenSelectServer) {
                         this.currentScreen.tick();
                     }
-                	
+
                     for(int tick = 0; tick < timer.frames; tick++)
                     {
                         ticksRan++;
@@ -1371,7 +1371,7 @@ public class Minecraft
                     if (stack == null) {
                         break bridge;
                     }
-                    if (this.playerController.onlyUseItemStackOn(thePlayer, currentWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced)) {
+                    if (this.playerController.placeItemStackOnTile(thePlayer, currentWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced)) {
                         this.playerController.swingItem(true);
                     }
                     if (stack.stackSize <= 0) {
@@ -1426,7 +1426,7 @@ public class Minecraft
             {
                 ItemStack stack = thePlayer.inventory.getCurrentItem();
                 int numItemsInStack = stack == null ? 0 : stack.stackSize;
-                if(playerController.useItemOn(thePlayer, currentWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced))
+                if(playerController.useOrPlaceItemStackOnTile(thePlayer, currentWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced))
                 {
                     flag = false;
                     playerController.swingItem(true);
@@ -1448,7 +1448,7 @@ public class Minecraft
         if(flag && clickType == 1)
         {
             ItemStack itemstack = thePlayer.inventory.getCurrentItem();
-            if(itemstack != null && playerController.useItem(thePlayer, currentWorld, itemstack))
+            if(itemstack != null && playerController.useItemStackOnNothing(thePlayer, currentWorld, itemstack))
             {
                 worldRenderer.itemRenderer.resetEquippedProgress();
             }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 0c2126d44..0ca398904 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -4,16 +4,16 @@ import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSign;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
-import net.minecraft.core.util.helper.ChatAllowedCharacters;
-import net.minecraft.core.net.packet.PacketSignUpdate;
-import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.packet.PacketSignUpdate;
+import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -63,7 +63,7 @@ public class ScreenSignEditor extends Screen
     {
         Keyboard.enableRepeatEvents(false);
         // I have no idea how the hell the world is null sometimes
-        // but thaboar was getting a crash from the world being null
+        // but thaboard was getting a crash from the world being null
         if(mc.currentWorld != null && mc.currentWorld.isClientSide)
         {
             mc.getSendQueue().addToSendQueue(new PacketSignUpdate(entitySign.x, entitySign.y, entitySign.z, entitySign.signText, entitySign.getPicture().getId(), entitySign.getColor().id));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index 09a62b274..25fb3a196 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -13,6 +13,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.render.texturepack.TexturePackList;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
@@ -220,7 +221,7 @@ public class TooltipElement extends Gui
 
 			if(showDescription) {
 				text.append('\n').append(formatDescription(itemStack.getItemDescription(), 16));
-			} else if (!(slot instanceof SlotResult)) {
+			} else if (!(slot instanceof SlotResult) && mc.gameSettings.itemDescriptions.value != DescriptionPromptEnum.NEVER_PROMPT) {
                 text.append('\n').append(formatDescription(trans.translateKeyAndFormat("gui.tooltip.prompt.description", mc.gameSettings.keyDescription.getKeyName()), 16));
             }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index b0cd70b6c..970ce5186 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -11,6 +11,7 @@ import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.SearchableGuidebookSection;
 import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.util.helper.ItemDragHandler;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
@@ -112,7 +113,7 @@ public abstract class ScreenContainerAbstract extends Screen
 		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 		if (inventoryplayer.getHeldItemStack() == null && slot != null && slot.hasItem())
 		{
-			boolean showDescription = mc.gameSettings.alwaysShowDescriptions.value || mc.gameSettings.keyDescription.isPressed();
+			boolean showDescription = DescriptionPromptEnum.showDescription(mc);
 			String str = tooltipElement.getTooltipText(slot.getItemStack(), showDescription, slot);
 			if(str.length() > 0)
 			{
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
index 2df94b267..9de269fac 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
@@ -8,6 +8,7 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.GuidebookPageManager;
 import net.minecraft.client.gui.guidebook.RecipePage;
+import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterDyeing;
 import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterLabel;
 import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterLabelDye;
 import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterMapDuplication;
@@ -19,6 +20,7 @@ import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterShapel
 import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterTool;
 import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterUndye;
 import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.achievement.Achievements;
@@ -28,6 +30,7 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryDyeing;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryLabel;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryLabelDye;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryMapDuplication;
@@ -65,6 +68,7 @@ public class RecipePageCrafting
         recipeToDisplayAdapterMap.put(RecipeEntryLabelDye.class, new DisplayAdapterLabelDye());
         recipeToDisplayAdapterMap.put(RecipeEntryMapDuplication.class, new DisplayAdapterMapDuplication());
         recipeToDisplayAdapterMap.put(RecipeEntryUndyeing.class, new DisplayAdapterUndye());
+        recipeToDisplayAdapterMap.put(RecipeEntryDyeing.class, new DisplayAdapterDyeing());
     }
 
     private final TooltipElement tooltipElement;
@@ -192,7 +196,7 @@ public class RecipePageCrafting
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
-                boolean showDescription = mc.gameSettings.alwaysShowDescriptions.value || mc.gameSettings.keyDescription.isPressed();
+                boolean showDescription = DescriptionPromptEnum.showDescription(mc);
                 String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterDyeing.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterDyeing.java
new file mode 100644
index 000000000..351da5211
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterDyeing.java
@@ -0,0 +1,68 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.SlotGuidebook;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryDyeing;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class DisplayAdapterDyeing implements RecipeDisplayAdapter<RecipeEntryDyeing>{
+    @Override
+    public List<SlotGuidebook> getSlots(RecipeEntryDyeing recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<SlotGuidebook> recipeSlots = new ArrayList<>();
+
+        int[] sharedMeta = new int[1];
+        int slotsAmount = 10;
+        for (int i = 0; i < slotsAmount - 1; i++)
+        {
+            if (i == 4) {
+                recipeSlots.add(new SlotGuidebookDye(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, new RecipeSymbol(new ItemStack(Items.DYE, 1, 26)), false, recipe, sharedMeta));
+            } else {
+                RecipeSymbol stack = recipe.inputSymbol;
+                recipeSlots.add(new SlotGuidebook(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
+            }
+        }
+
+        int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
+        recipeSlots.add(new SlotGuidebookDyeResult(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(new ItemStack(recipe.output.getItem(), 8, 26)), false, recipe, sharedMeta).setAsOutput());
+
+        return recipeSlots;
+    }
+
+    public static class SlotGuidebookDye extends SlotGuidebook {
+        private final int[] metadata;
+        public SlotGuidebookDye(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, int[] sharedMeta) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.metadata = sharedMeta;
+        }
+
+        @Override
+        public void showRandomItem() {
+            this.metadata[0] = new Random().nextInt(16);
+            item = new ItemStack(Items.DYE, 1, this.metadata[0]);
+        }
+    }
+
+    public static class SlotGuidebookDyeResult extends SlotGuidebook {
+        private final int[] metadata;
+        private final RecipeEntryDyeing recipeEntryDyeing;
+        public SlotGuidebookDyeResult(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryDyeing recipe, int[] sharedMeta) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.metadata = sharedMeta;
+            this.recipeEntryDyeing = recipe;
+        }
+
+        @Override
+        public void showRandomItem() {
+            super.showRandomItem();
+            this.item = new ItemStack(this.item.itemID, this.item.stackSize, recipeEntryDyeing.getOutputMetaFromInputMeta(this.metadata[0]));
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterTool.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterTool.java
index 99e4931e4..ba7c1fca1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterTool.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterTool.java
@@ -51,7 +51,7 @@ public class DisplayAdapterTool implements RecipeDisplayAdapter<RecipeEntryCraft
                         newItem = list.get(r.nextInt(list.size()));
                     }
                 }
-                item = newItem;
+                item = new ItemStack(newItem);
             }
             item.setMetadata(r.nextInt(item.getMaxDamage()));
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index af98df2dd..892b461cc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -6,6 +6,7 @@ import net.minecraft.client.gui.ItemElement;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.render.*;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -280,7 +281,7 @@ public class GuidebookPageMob
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
-                boolean showDescription = mc.gameSettings.alwaysShowDescriptions.value || mc.gameSettings.keyDescription.isPressed();
+                boolean showDescription = DescriptionPromptEnum.showDescription(mc);
                 String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
index bafa22b81..8329a933b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
@@ -9,6 +9,7 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.achievement.Achievements;
@@ -147,7 +148,7 @@ public class RecipePageBlastSmelting
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
-                boolean showDescription = mc.gameSettings.alwaysShowDescriptions.value || mc.gameSettings.keyDescription.isPressed();
+                boolean showDescription = DescriptionPromptEnum.showDescription(mc);
                 String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
index 461fe1cd7..d75779401 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
@@ -9,6 +9,7 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.achievement.Achievements;
@@ -147,7 +148,7 @@ public class RecipePageSmelting
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
-                boolean showDescription = mc.gameSettings.alwaysShowDescriptions.value || mc.gameSettings.keyDescription.isPressed();
+                boolean showDescription = DescriptionPromptEnum.showDescription(mc);
                 String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
index d8d6506b9..0910282f2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
@@ -9,6 +9,7 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.WeightedRandomBag;
@@ -196,7 +197,7 @@ public class RecipePageTrommel
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
-                boolean showDescription = mc.gameSettings.alwaysShowDescriptions.value || mc.gameSettings.keyDescription.isPressed();
+                boolean showDescription = DescriptionPromptEnum.showDescription(mc);
                 String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index b8bd2f426..38b60524c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -82,7 +82,7 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.armorDurabilityOverlay))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.heldItemCountOverlay))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.heldItemTooltips))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.alwaysShowDescriptions))
+                .withComponent(new ToggleableOptionComponent(mc.gameSettings.itemDescriptions))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.hideUndiscoveredItems))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.dynamicCursor))
             )
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index a45da7a3a..51b6ece0e 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -20,6 +20,7 @@ import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.Colorblindness;
 import net.minecraft.client.render.font.Fonts;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.client.option.enums.LightmapStyle;
@@ -131,7 +132,7 @@ public class GameSettings {
 	public OptionBoolean heatHaze = new OptionBoolean(this, "heatHaze", false);
 	public OptionBoolean alphaMenu = new OptionBoolean(this, "old", false);
 	public OptionBoolean enableItemClumping = new OptionBoolean(this, "enableItemClumping", true);
-	public OptionBoolean alwaysShowDescriptions = new OptionBoolean(this, "alwaysShowDescriptions", false);
+	public OptionEnum itemDescriptions = new OptionEnum<>(this, "itemDescriptions", DescriptionPromptEnum.class, DescriptionPromptEnum.PROMPT);
 	public OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
 	public OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
 	public OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", true);
diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/DescriptionPromptEnum.java b/game/client/src/main/java/net/minecraft/client/option/enums/DescriptionPromptEnum.java
new file mode 100644
index 000000000..16b1e0b24
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/DescriptionPromptEnum.java
@@ -0,0 +1,14 @@
+package net.minecraft.client.option.enums;
+
+import net.minecraft.client.Minecraft;
+import org.jetbrains.annotations.NotNull;
+
+public enum DescriptionPromptEnum {
+    NEVER_PROMPT,
+    PROMPT,
+    ALWAYS_SHOW;
+
+    public static boolean showDescription(@NotNull final Minecraft minecraft) {
+        return (minecraft.gameSettings.itemDescriptions.value == DescriptionPromptEnum.ALWAYS_SHOW || minecraft.gameSettings.keyDescription.isPressed());
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 7d3ad0cc0..151533f9e 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -228,20 +228,6 @@ public abstract class PlayerController {
 		return mc.thePlayer.getGamemode().getEntityReachDistance();
 	}
 
-	public boolean useItem(Player player, World world, ItemStack stack) {
-		if (!player.getGamemode().canInteract()) return false;
-		int prevStackSize = stack.stackSize;
-		ItemStack newItemStack = stack.useItemRightClick(world, player);
-		if(newItemStack != stack || newItemStack.stackSize != prevStackSize) {
-			player.inventory.mainInventory[player.inventory.getCurrentItemIndex()] = newItemStack;
-			if(newItemStack == null || newItemStack.stackSize <= 0) {
-				player.inventory.mainInventory[player.inventory.getCurrentItemIndex()] = null;
-			}
-			return true;
-		}
-		return false;
-	}
-
 	public void initPlayer(Player player) {
 		player.yRot = -180F;
 	}
@@ -261,7 +247,12 @@ public abstract class PlayerController {
 	public void adjustPlayer(Player player) {
 	}
 
-	public boolean useItemOn(@NotNull Player player, @NotNull World world, @Nullable ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+	/**
+	 * Used to dynamically use or place an ItemStack on any given tile.
+	 * <p>
+	 * (i.e. interacting with a chest while holding a block, defaulting to opening the chest when standing, vs. placing the block when crouched)
+	 */
+	public boolean useOrPlaceItemStackOnTile(@NotNull Player player, @NotNull World world, @Nullable ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
 	{
 		if (!player.getGamemode().canInteract()) return false;
 		int blockId = world.getBlockId(blockX, blockY, blockZ);
@@ -297,7 +288,31 @@ public abstract class PlayerController {
 		}
 	}
 
-	public boolean onlyUseItemStackOn(@NotNull Player player, @NotNull World world, @Nullable ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	/**
+	 * Used to specifically use an ItemStack on nothing, most commonly defaulting to typical "item use" behavior.
+	 * <p>
+	 * (i.e. throwing a fishing rod or shooting a bow)
+	 */
+	public boolean useItemStackOnNothing(Player player, World world, ItemStack stack) {
+		if (!player.getGamemode().canInteract()) return false;
+		int prevStackSize = stack.stackSize;
+		ItemStack newItemStack = stack.useItemRightClick(world, player);
+		if(newItemStack != stack || newItemStack.stackSize != prevStackSize) {
+			player.inventory.mainInventory[player.inventory.getCurrentItemIndex()] = newItemStack;
+			if(newItemStack == null || newItemStack.stackSize <= 0) {
+				player.inventory.mainInventory[player.inventory.getCurrentItemIndex()] = null;
+			}
+			return true;
+		}
+		return false;
+	}
+
+	/**
+	 * Used to exclusively place an ItemStack. No interactions, just placing a held ItemStack.
+	 * <p>
+	 * (i.e. placing blocks using easy bridge)
+	 */
+	public boolean placeItemStackOnTile(@NotNull Player player, @NotNull World world, @Nullable ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if (!player.getGamemode().canInteract()) return false;
 		if (player.getHeldObject() == null) {
 			if (itemstack == null) { // No stack then do nothing
